//############################################################################
//
// LaserBoy !!!
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#include "ez_uail_common.hpp"

//############################################################################
const double pi                = (4 * atan(1.0)) ;
const double two_pi            = (pi * 2.0)      ;
const double quarter_pi        = (pi / 4.0)      ;
const double half_pi           = (pi / 2.0)      ;
const double three_quarters_pi = (3 * quarter_pi);
const double one_degree        = (pi / 180.0)    ;
const double one_radian        = (180.0 / pi)    ;

//############################################################################
unsigned char byte_primes[55] = 
{
    1, 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41,
    43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101,
    103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157,
    163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223,
    227, 229, 233, 239, 241, 251
};

//############################################################################
float ez_random_01() // returns a float between 0 & 1.
{
    return ((float)(rand()) / (float)RAND_MAX);
}

//############################################################################
float ez_random_neg_to_pos_1() // returns a float between -1 & 1.
{
    return ez_random_01() - ez_random_01();
}

//############################################################################
bool get_dxf_pair(ifstream& in, int& group_code, string& entity_string)
{
    char line[256];
    in >> group_code;
    if(group_code != -1)
    {
        while(isspace(in.peek()))
            in.get(); // eat the '\r''\n'

        in.getline(line, 255);
        entity_string = line;

        int i = entity_string.size() - 1;
        while(!isgraph(entity_string[i]))
            i--;

        entity_string = entity_string.substr(0, i + 1);
    }
    return (group_code != 0 && !in.eof());
}

//############################################################################
bool get_dxf_pair(ifstream& in, int& group_code, char entity_string[256])
{
    in >> group_code;
    if(group_code != -1)
    {
        while(isspace(in.peek()))
            in.get(); // eat the '\r''\n'
        in.getline(entity_string, 255);
    }
    return (group_code != 0 && !in.eof());
}

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################
